/* HW SETUP */
void hw_setup()
{

	RDPU=0;							// DISABLE INTERNAL PULL UP IN PORTD
	RBPU=0;							// ENABLE INTERNAL PULL UP IN PORTB
	ADCON1=0x0F;
}
void lcd_port_init()
{
	TRISD0=0;						// LCD DATA PIN D4
	TRISD1=0;						// D5
	TRISD2=0;						// D6
	TRISD3=0;						// D7
	TRISB4=0;						// RS
	TRISB3=0;						// EN
}
void tristate_port()
{
	TRISE0=0;						// TRIGGER FOR USART ENABLE
	LATE0=1;						// SET PORT AS HIGH DEFAULT
	TRISB5=0;						// TRIGGER FOR SPI CLOCK OUT
	LATB5=1;						// SET PORT AS HIGH DEFAULT
	TRISB2=1;						// INPUT PORT FOR ACK
	TRISC0=0;						// OUTPUT PORT FOR DRDY
	TRISA3=0;
	LATA3=1;
}
void spi_port_init()
{

	TRISC7=0;						// SD0
	LATC7=1;						// DEFAULT VALUE						
	TRISB0=1;						// SDI	
	TRISB1=0;						// SCK
	TRISD7=0;						// CS
	TRISC1=0;						// PWM2
	TRISD6=0;
	TRISC2=0;
}
void usart_port_init()
{
	TRISC7=1;						// INPUT PORT FOR RX
	TRISC6=0;						// OUTPUT PORT FOR TX
}
void delay(unsigned char dly)
{
	for(unsigned char k=0;k<=dly;k++)
		Delay10KTCYx(0xFF);
}