
#define CS LATD7
void command(unsigned char cmd,long int arg,unsigned char crc)
{
	spi_write(0xFF);
	spi_write(0x40+cmd);
	spi_write((arg>>24));
	spi_write((arg>>16));
	spi_write((arg>>8));
	spi_write((arg));
	spi_write(crc);
}

unsigned char sd_init()
{
	unsigned char cmd41=0xff,nn=0;
	unsigned char cmd8[2];
	unsigned int sd_cnt=0;
	LATA3=0;
	
	SSPCON1=0b00100010;
	SMP=1;
	CKE=1;
	CKP=0;
	SSPEN=1;

	CS=1;
	for(nn=0;nn<=50;nn++)
	spi_write(0xFF);
	CS=0;
	
	/* CMD0*/
	sd_cnt=0;
	command(0,0,0x95);
	while((readdata!=0x01)&&(sd_cnt<1000))
	{
		spi_read();
		sd_cnt++;
		if(sd_cnt>=1000)
		{
			string("CMD0 ERROR");
			return 0;
		}	
	}
	/* CMD8*/
	sd_cnt=0;
	command(0x08,0x000001AA,0x87);
	while((cmd8[1]!=0xAA)&&(sd_cnt<1000))
	{
		cmd8[0]=readdata;
		spi_read();
		cmd8[1]=readdata;
		sd_cnt++;
		if(sd_cnt>=1000)
		{
			string("CMD8 ERROR");
			return 0;
		}	
	}
	/* CMD55*/
	sd_cnt=0;
	command(55,0,0x65);
	while((readdata!=0x01)&&(sd_cnt<1000))
	{
		spi_read();
		sd_cnt++;
		if(sd_cnt>=1000)
		{
			string("CMD55 ERROR");
			return 0;
		}	
	}
	CS=1;
	spi_write(0xFF);
	CS=0;
	__delay_us(20);
	/* CMD41*/
	sd_cnt=0;
	command(41,0x40000000,0x5F);
	while((cmd41!=0x00)&&(sd_cnt<1000))
	{		
		CS=1;
		spi_write(0xFF);
		CS=0;
		command(55,0,0x65);
		spi_read();
		CS=1;
		spi_write(0xFF);
		CS=0;		
		command(41,0x40000000,0x5F);
		cmd41=readdata;
		sd_cnt++;
		if(sd_cnt>=1000)
		{
			string("CMD41 ERROR");
			return 0;
		}	
	}
	
return 1;
}

